<template>
  <div class="inputNumber">
    <AppButton
      @click.native="minus"
      :classes="['_cut-right']"
      :disabled="total === minValue">
      <template #button-item>
        <img
          svg-inline
          src="~/assets/svg/redesign/count-minus.svg">
      </template>
    </AppButton>
    <input
      class="input-field"
      type="text"
      @input="checkValue"
      v-model="total">
    <AppButton
      @click.native="plus"
      :classes="['_cut-left']"
      :disabled="total === maxValue">
      <template #button-item>
        <img
          svg-inline
          src="~/assets/svg/redesign/count-plus.svg">
      </template>
    </AppButton>
  </div>
</template>

<script>
import AppButton from '~/components/redesign/app-buttons/app-button';

export default {
  name: 'AppInputNumber',
  components: {
    AppButton,
  },
  props: {
    value: {
      default: 1,
      type: Number,
    },
    minValue: {
      default: 1,
      type: Number,
    },
    maxValue: {
      type: Number,
      default: Infinity,
    },
    step: {
      default: 1,
      type: Number,
    },
  },
  data() {
    const total = this.value;
    return {
      total,
    };
  },
  methods: {
    minus() {
      if (this.total !== this.minValue) {
        this.total = this.total - this.step;
        this.$emit('changeCount', this.total);
      }
    },
    plus() {
      if (this.total !== this.maxValue) {
        this.total = this.total + this.step;
        this.$emit('changeCount', this.total);
      }
    },
    checkValue() {
      let num = Number(this.total) || 1;
      if (num > this.maxValue) num = this.maxValue;
      if (num < this.minValue) num = this.minValue;
      this.total = num;
      this.$emit('changeCount', Number(num));
    },
  },
};
</script>

<style lang="postcss">
.inputNumber {
  display: flex;
  justify-content: flex-start;
  align-items: center;

  .input-field {
    width: 3.25rem;
    text-align: center;
    border-right: none;
    border-left: none;
    border-radius: 0;
    box-shadow: none;
  }

  .button {
    flex-shrink: 0;
    width: var(--btn-height-regular);
    padding: 0;
    &:disabled .svg {
      stroke: var(--btn-disabled-svg-fill);
    }
  }

  &._small {
    .input-field, .button {
      height: var(--select-small-height);
      min-height: var(--select-small-height);
      width: 2.5rem;
      padding-left: 0.25rem;
      padding-right: 0.25rem;
    }
    .button {
      width: var(--select-small-height);
    }
  }

  @media screen and (max-width: 1200px) {
    .input-field {
      width: 3.875rem;
      height: var(--btn-height-huge);
    }

    .button {
      width: var(--btn-height-huge);
      height: var(--btn-height-huge);
      .svg {
        stroke-width: 1.5;
        width: 1.5rem;
        height: auto;
      }
    }
  }

  @media screen and (max-width: 980px) {
    &._small {
      .input-field, .button {
        height: var(--btn-height-medium);
        min-height: var(--btn-height-medium);
        width: 4rem;
        padding-left: 0.25rem;
        padding-right: 0.25rem;
      }
      .button {
        width: var(--btn-height-medium);
      }
    }
  }
}
</style>
